/*
 * main_simple.c
 *
 *  Created on: 11.10.2009
 *      Author: daniel
 */

/*
 * 	Doku, siehe http://www.mikrocontroller.net/articles/AVR_FAT32
 *	Autor: Daniel R.
 */

#include <stdlib.h>
#include <avr/interrupt.h>
#include <avr/io.h>

#include "config.h"	// hier werden alle nötigen konfigurationen vorgenommen !
#include "file.h"
#include "fat.h"
#include "mmc.h"		// hardware abhängig
#include "uart.h"		// hardware abhängig


//*****************************************************************************************************************
void main(void){

	uinit();								// uart initialisierung

	uputs((unsigned char*)"\nBoot");

	while (mmc_init() == FALSE){			// es wird solange versucht die karte zu initialisieren bis es klappt
		nop();
	}

	uputs((unsigned char*)"...");

	if(TRUE==fat_loadFatData()){			// fat initialisierung funktioniert?

		uputs((unsigned char*)"Ok\n");	// wenn auf dem terminal "Boot... OK" zu lesen ist, ist init ok. jetzt kann man schreiben/lesen

		unsigned char c;
		unsigned long int seek;
		unsigned char file_name[12]="TEST    TXT";


		// rückgabewert MMC_FILE_NEW bedeutet, datei war nicht vorhanden, aber wurde grade angelegt. bereit zum schreiben !
		if(MMC_FILE_NEW==ffopen(file_name)){

			seek=26;	// es werden 26 zeichen in die datei geschrieben, plus 2 weitere, nämlich der zeilenumbruch
			c='a';		// ab dem zeichen ascii a wird gechrieben
			do{
				ffwrite(c++);
			}while(--seek);

			// zeilenumbruch in der datei
			ffwrite(0x0D);
			ffwrite(0x0A);

			ffclose();
		}

		// rückgabewert MMC_FILE_EXISTS bedeutet, datei ist vorhanden und wurde geöffnet. bereit zum lesen !
		if(MMC_FILE_EXISTS==ffopen(file_name)){

			seek=file.length;	// hier wird die dateilänge auf die variable gespeichert, mit der komplett durch die datei gegangen wird.
								// das geht so schneller, als die variable bis file.length hoch zählen zu lassen.
			do{
				c=ffread();
				uputc(c);
			}while(--seek);

			ffclose();
		}


		uputs((unsigned char*)"\n");

		// anzeigen des verzeichnis inhalts, hier wird quasi die adresse der funktion übergeben, mit der angezeigt werden soll.
		// erwartet wird eine funktion der form : void funName(unsigned char*); siehe auch uart.c
		ffls(uputs);
	}
}









